%Calcula alfa para el metodo del maximo descenso
%en funcion del punto actual y el terreno
function alfa = calcula_alfa(X,Y,Z,x,y)
	rho = 0.1; % rho entre (0,1)
	c = 1e-4; % c entre (0,1) normalmente ese valor fijo
	alfa_inicial = 1;

	gradiente = calcula_gradiente(X,Y,Z,x,y);  %calcula el gradiente en ese punto
	p=-gradiente/norm(gradiente);              %guarda el "menos gradiente" en un vector unitario de tamao 2
	alfa= alfa_inicial;
	u =([x,y]+alfa*p);
	%si alfa es demasiado grande, puede hacer que el nuevo punto se salga del terreno
	%corregimos si se da este caso
	while ~esta_dentro(X,Y,u)
		alfa = alfa / 2;
		u =([x,y]+alfa*p);
	end

	F = evaluaZ(X,Y,Z,u(1),u(2));            %F(alfa) = f(Xk + alfa*Pk), valor de z en el pto destino con el alfa inicial
	f = evaluaZ(X,Y,Z,x,y);                  %f(Xk), valor de z en el pto de partida
	                                         %mientras f(Xk + alfa*Pk) > f(Xk) + c*alfa*grad(f)*Pk'
	while F > f+(c*alfa)*gradiente*p'        %p' por el producto de vectores
		alfa = alfa*rho;
		u =([x,y]+alfa*p);
		F = evaluaZ(X,Y,Z,u(1),u(2)); %F(alfa) = f(Xk + alfa*Pk)
	end

return;
