%minimiza la funcion expresada con X,Y,Z con el metodo del maximo
%descenso. Po es el punto inicial.
%devuelve la trayectoria T de puntos hasta llegar al minimo,
%la solucion y el valor de la funcion para ese punto
%
%niter es el numero de iteraciones y alfas es un vector con los
%distintos alfas adoptados en cada paso del metodo
%
function [T,sol,z,niter,alfas] = calcula_trayectoria(X,Y,Z,Po)

if length(X) ~= size(Z,2) || length(Y) ~= size(Z,1)
	error('La matriz Z tiene que tener las dimensiones de X x Y'); %asegura que la matriz Z tenga las dimensiones adecuadas
end

npuntos = 0;
niter = 0;
P = Po; %vector de tamao 2 que almacena el pto [X0,Y0]
Panterior = P + [10,10]; %iniciamos a un numero diferente de P
TOL = 0.0001; %Tolerancia para una solucion razonable

while esta_dentro(X,Y,P) && niter < 1000 && norm(P-Panterior) > TOL %mientras este dentro de la malla, y numero de iteraciones no sea mayor de 1000 (si es + de 1000 es que se metio en un bucle infinito) y la norma de P-Panterior (esta caminando en puntos tan proximos que esta en el minimo)sea mayor que la tolerancia, se repetira el bucle
	npuntos = npuntos +1;
	T(npuntos,:) = [P(1),P(2),evaluaZ(X,Y,Z,P(1),P(2))];   %guarda fila a fila los puntos de la trayectoria, el valor de Z se obtiene con la funcion evaluaZ
	Pk = evaluaPk(X,Y,Z,P(1),P(2));                        %calculamos el "menos gradiente" en ese punto
	alfa = calcula_alfa(X,Y,Z,P(1),P(2));                  %calculamos alfa para este paso 
	alfas(npuntos) = alfa;                                 %almacenamos el valor de alfa para esa iteracion
	Panterior = P;
	P = P + alfa*Pk;                                       %nuevo pto
    niter = niter +1;
end
sol = T(npuntos,1:2);                                      %guarda en "sol" los valores de las 2 primeras columnas (X,Y) de la ultima fila de la matriz de la trayectorias, T                                  
z = T(npuntos,3);                                          %guarda en "z" el valor de la 3 columna y la ultima fila 
fprintf('Numero de iteraciones: %d\n',niter);              
fprintf('Solucion: (%d,%d)\n',T(npuntos,1),T(npuntos,2));  %muestra en pantalla las coordenadas (X,Y) del ultimo pto 
fprintf('Valor de z: %d\n',T(npuntos,3));                  %muestra el valor de "z" del ultimo pto


return;
