%Evalua el valor de z en el terreno definido por X,Y,Z en el punto (x,y)
function z = evaluaZ(X,Y,Z,x,y)
if length(X) ~= size(Z,2) || length(Y) ~= size(Z,1) %size(Z,2)-> devuelve el numero de columnas de la matriz Z; size(Z,1) -> devuelve el numero de filas de la matriz Z; se compara el numero de columnas de Z con el numero de elementos del vector X y se compara el numero de filas de Z con el numero de elementos del vector Y
	error('La matriz Z tiene que tener las dimensiones de X x Y'); %mensaje de error
end
if x < X(1) || x > X(length(X))
   error('x tiene que estar en el intervalo [%d,%d]',X(1),X(length(X)));
end                                                                        %se evalua si el pto esta dentro de los limites de la malla
if y < Y(1) || y > Y(length(Y))
   error('y tiene que estar en el intervalo [%d,%d]',Y(1),Y(length(Y)));
end

%Calculamos la Z interpolando con los puntos que definen el terreno
z = interp2(X,Y,Z,x,y,'linear');
return;

%>> help interp2

%  INTERP2 2-D interpolation (table lookup).
%  ZI = INTERP2(X,Y,Z,XI,YI) interpolates to find ZI, the values of the
%  underlying 2-D function Z at the points in matrices XI and YI.
%  Matrices X and Y specify the points at which the data Z is given.
%  Out of range values are returned as NaN.