
function trayectoria_descenso

syms('F','OK','longX','longY','N','FLAG','NAME','OUP');
syms('M','FLAG0','DeltaX','X','s','DeltaY','XD','YD','ZD','NTOT');
syms('IP1','JP1','IP2','JP2','IP3','JP3','IP4','JP4');
syms('X1','YI','Z1','X2','Y2','Z2','X3','Y3','Z3','X4','Y4','Z4');
syms('D1','D2','D3','D4','N1','N2','N3','N4');
TRUE = 1;
FALSE = 0;
fprintf(1,'Formula de Interpolacion de lagrange en 2D\n');
OK = FALSE;
while OK == FALSE
   fprintf(1,'Elija la forma de entrada de datos:\n');
   fprintf(1,'1.  Generar datos usando una funcion F\n');
   fprintf(1,'2. Entrada desde un fichero de texto\n');
   fprintf(1,'Escriba 1 o 2 \n');
   FLAG = input(' ');
   if FLAG == 1 | FLAG == 2
      OK = TRUE;
   end
end
OK = FALSE;
while OK == FALSE
   fprintf(1,'Escriba la longitud de X y de Y en lineas separadas.\n');
   longX = input(' ');
   longY = input(' ');
   fprintf(1,'Escriba el numero de puntos en X y en Y en lineas separadas.\n');
   N = input(' ');
   M = input(' ');
   if longX > 0 & longY > 0 & N > 0 & M > 0
      X = zeros(N,M,3); %Almacena la los valores X,Y,Z para los puntos del espacio discretizado
      OK = TRUE;
   end
end
DeltaX = longX/(N-1);
DeltaY = longY/(M-1);

if FLAG == 1 %Generar datos usando una funcion
   fprintf(1,'Escriba la funcion F(x,y) en terminos de x e y\n');
   fprintf(1,'Por ejemplo: y-x^2+1\n');
   s = input(' ','s');
   F = inline(char(s),'x','y');
   for j = 1 : M
      for i = 1 : N
         X(i,j,1) = (i-1)*DeltaX;
         X(i,j,2) = (j-1)*DeltaY;
         X(i,j,3) = F(X(i,j,1),X(i,j,2));
      end;
   end;
   fprintf(1,'Elija la forma de salida de datos:\n');
   fprintf(1,'1. Pantalla\n');
   fprintf(1,'2. Fichero de texto\n');
   fprintf(1,'Escriba 1 o 2\n');
   FLAG0 = input(' ');
   if FLAG0 == 2
      fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
      fprintf(1,'Por ejemplo   A:\\OUTPUT.DTA\n');
      NAME = input(' ','s');
      OUP = fopen(NAME,'wt');
   else
      OUP = 1;
   end;
   fprintf(OUP, '%11.5f %11.5f %11.5f %11.5f\n', longX,longY,N,M);
   for j = 1 : M
      for i = 1 : N
         fprintf(OUP, '%11.5f %11.5f %11.5f\n', X(i,j,1),X(i,j,2),X(i,j,3));
      end;
   end;
   if OUP ~= 1
      fclose(OUP);
      fprintf(1,'Fichero de salida creado satisfactoriamente \n',NAME);
   end;
end;
if FLAG == 2
   fprintf(1,'Esta creado un fichero de texto con los datos en TRES columnas?\n');
   fprintf(1,'donde la primera fila...?? e\n');
   fprintf(1,'Escriba Y o N\n')
   E = input(' ','s');
   if E == 'Y' | E == 'y'
      fprintf(1,'Escriba el nombre del fichero de la forma - ');
      fprintf(1,'disco:\\nombre.ext\n');
      fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
      NAME = input(' ','s');
      INP = fopen(NAME,'rt');
      OK = FALSE;
      while OK == FALSE
         for j = 1 : M
            for i = 1 : N
               for k = 1 : 3
                  X(i,j,k) = fscanf(INP, '%f',1);
               end;
            end;
         end;
      end;
   end;
end;

%Interpolacion de Lagrange
fprintf(1,'Introduzca un nuevo numero de puntos para x y para y en lineas separadas\n');
NN = input(' ');
MM = input(' ');
if  NN > N & MM > M
   XX = zeros(NN,MM,3); %almacenaremos los puntos del espacio interpolado
   XD = zeros(1,NN);
   YD = zeros(1,MM);
   ZD = zeros(NN,MM);
   OK = TRUE;
end
%nuevos valores Delta
CC = longX/(NN-1);
DD = longY/(MM-1);
for j = 1 : MM
   for i = 1 : NN
      XX(i,j,1) = (i-1)*CC;
      XX(i,j,2) = (j-1)*DD;

      IP1 = fix(XX(i,j,1)/DeltaX)+1;
      JP1 = fix(XX(i,j,2)/DeltaY)+1;
      if i==NN
         IP1 = fix(XX(i,j,1)/DeltaX);
      end;
      if j==MM
         JP1 = fix(XX(i,j,2)/DeltaY);
      end;
      IP2 = IP1+1;
      JP2 = JP1;
      IP3 = IP1+1;
      JP3 = JP1+1;
      IP4 = IP1;
      JP4 = JP1+1;

      X1 = X(IP1,JP1,1);
      Y1 = X(IP1,JP1,2);
      X2 = X(IP3,JP3,1);
      Y2 = X(IP3,JP3,2);
      Z1 = X(IP1,JP1,3);
      Z2 = X(IP2,JP2,3);
      Z3 = X(IP3,JP3,3);
      Z4 = X(IP4,JP4,3);

      D1 = ((X2-X1)*(Y2-Y1));
      D2 = -D1;
      D3 = D1;
      D4 = D1;

      N1 = (((X2-XX(i,j,1))*(Y2-XX(i,j,2)))/D1);
      N2 = (((X1-XX(i,j,1))*(Y2-XX(i,j,2)))/D2);
      N3 = (((X1-XX(i,j,1))*(Y1-XX(i,j,2)))/D3);
      N4 = (((XX(i,j,1)-X2)*(Y1-XX(i,j,2)))/D4);

      XX(i,j,3) = (N1*Z1+N2*Z2+N3*Z3+N4*Z4); % nuevo valor de Z

      ZD(i,j)=XX(i,j,3);
   end;
end;
ZD = ZD';
for i = 1 : NN
   XD(i)=(i-1)*CC;
end;
for j = 1 : MM
   YD(j)=(j-1)*DD;
end;
figure;
surf(XD,YD,ZD);
title('Interpolacion de Lagrange en 2D');
xlabel('Eje X');
ylabel('Eje Y');
hold on;
fprintf(1,'\n');

%Introduccion del punto inicial de la trayectoria.
fprintf(1,'Introduzca las coordenadas X e Y del punto inicial de la trayectoria en lineas separadas.\n');
X0 = input(' ');
Y0 = input(' ');

if ~esta_dentro(XD,YD,[X0,Y0]) %con esta funcion se evalua si el punto esta dentro de los limites de la malla, el simbolo "~" es una negacion logica
    error('El punto tiene que estar dentro del intervalo de trabajo'); %mensaje de error pq el punto tiene que estar dentro de la malla
end

Z0 = evaluaZ(XD,YD,ZD,X0,Y0);    %Evalua el valor de z en el terreno definido por X,Y,Z en el punto (x,y) y se guarda en Z0
fprintf('El punto inicial de la trayectoria es(%d,%d,%d)\n',X0,Y0,Z0); %escribe en pantalla el punto inicial (X0,Y0) y la Z0 correspondiente calculada en la linea anterior
plot3(X0,Y0,Z0,'w+');  %dibuja una "+ blanca" en ese punto de la superficie

[T,sol,z,niter,alfas] = calcula_trayectoria(XD,YD,ZD,[X0,Y0]); % minimiza la funcion expresada con X,Y,Z con el metodo del maximo descenso. Po es el punto inicial. devuelve la trayectoria T de puntos hasta llegar al minimo,la solucion y el valor de la funcion para ese punto, niter es el numero de iteraciones y alfas es un vector con los distintos alfas adoptados en cada paso del metodo
plot3(T(:,1),T(:,2),T(:,3),'w-');  %dibuja todos los puntos de la trayectoria uniendolos con "- blancos". Los puntos vienen representados en cada fila de la matriz T (con 3 columnas y n filas), con cada una de las variables (X,Y,Z) asociadas a una columna.

return;


